class Fractal {
  PGraphics imagen;

  int anchoLienzo, altoLienzo;  
  int cantidad;
  float factor[];
  float x[];
  float y[];
  float ang[];

  float iniTinte;
  float iniSatura;
  float iniBrillo;
  float incTinte;
  float incSatura;
  float incBrillo;
  float transparencia;

  float CiniTinte;
  float CiniSatura;
  float CiniBrillo;
  float CincTinte;
  float CincSatura;
  float CincBrillo;
  float Ctransparencia;

  Fractal( int ancho_, int alto_, float adn[] ) {

    float factor_[] = new float[3];
    float x_[] = new float[3];
    float y_[] = new float[3];
    float ang_[] = new float[3];

    arrayCopy( adn, 2, factor_, 0, 3 );
    arrayCopy( adn, 5, x_, 0, 3 );
    arrayCopy( adn, 8, y_, 0, 3 );
    arrayCopy( adn, 11, ang_, 0, 3 );

    inicio( ancho_, alto_, int( adn[0] ), //cantidad
    int( adn[1] ), //nivel
    factor_, x_, y_, ang_, 
    adn[14], //iniTinte
    adn[15], //iniSatura
    adn[16], //iniBrillo_ , 
    adn[17], //incTinte_ , 
    adn[18], //incSatura_ ,
    adn[19], // incBrillo_ ,
    adn[20], //transparencia_ ,
    adn[21], //CiniTinte_ , 
    adn[22], //CiniSatura_ , 
    adn[23], //CiniBrillo_ , 
    adn[24], //CincTinte_ , 
    adn[25], //CincSatura_ ,
    adn[26], // CincBrillo_ ,
    adn[27]  //Ctransparencia_ 
    );
  }

  Fractal( int ancho_, int alto_, int cantidad_, int nivel, 
  float factor_[], float x_[], float y_[], float ang_[], 
  float iniTinte_, float iniSatura_, float iniBrillo_, 
  float incTinte_, float incSatura_, float incBrillo_, 
  float transparencia_, 
  float CiniTinte_, float CiniSatura_, float CiniBrillo_, 
  float CincTinte_, float CincSatura_, float CincBrillo_, 
  float Ctransparencia_ 
    ) {

    inicio( ancho_, alto_, cantidad_, nivel, 
    factor_, x_, y_, ang_, 
    iniTinte_, iniSatura_, iniBrillo_, 
    incTinte_, incSatura_, incBrillo_, 
    transparencia_, 
    CiniTinte_, CiniSatura_, CiniBrillo_, 
    CincTinte_, CincSatura_, CincBrillo_, 
    Ctransparencia_ 
      );
  }

  void inicio( int ancho_, int alto_, int cantidad_, int nivel, 
  float factor_[], float x_[], float y_[], float ang_[], 
  float iniTinte_, float iniSatura_, float iniBrillo_, 
  float incTinte_, float incSatura_, float incBrillo_, 
  float transparencia_, 
  float CiniTinte_, float CiniSatura_, float CiniBrillo_, 
  float CincTinte_, float CincSatura_, float CincBrillo_, 
  float Ctransparencia_ 
    ) {

    anchoLienzo = ancho_;
    altoLienzo = alto_;

    cantidad = cantidad_;

    factor = factor_ ;
    x = x_;
    y = y_;
    ang = ang_;

    iniTinte = iniTinte_;
    iniSatura = iniSatura_;
    iniBrillo = iniBrillo_;

    incTinte = incTinte_;
    incSatura = incSatura_;
    incBrillo = incBrillo_;

    transparencia = transparencia_;

    CiniTinte = CiniTinte_;
    CiniSatura = CiniSatura_;
    CiniBrillo = CiniBrillo_;

    CincTinte = CincTinte_;
    CincSatura = CincSatura_;
    CincBrillo = CincBrillo_;

    Ctransparencia = Ctransparencia_;

    imagen = createGraphics( anchoLienzo, altoLienzo );

    imagen.beginDraw();
    imagen.smooth();
    imagen.colorMode(HSB);
    imagen.background( iniTinte, iniSatura, iniBrillo );

    ejecutar( nivel, 
    anchoLienzo, 
    altoLienzo, 
    iniTinte, 
    iniSatura, 
    iniBrillo, 
    CiniTinte, 
    CiniSatura, 
    CiniBrillo 
      );

    imagen.endDraw();
  }

  void ejecutar( int nivel, 
  float ancho, 
  float alto, 
  float tinte, 
  float satura, 
  float brillo, 
  float Ctinte, 
  float Csatura, 
  float Cbrillo
    ) {
    if ( nivel>0 ) {
      imagen.rectMode( CENTER );      
      imagen.fill( tinte, satura, brillo, transparencia );
      imagen.stroke( Ctinte, Csatura, Cbrillo, Ctransparencia );

      float proxTinte = ( tinte+incTinte ) % 256;
      float proxSatura = ( satura+incSatura ) % 256;
      float proxBrillo = ( brillo+incBrillo ) % 256;

      float CproxTinte = ( Ctinte+CincTinte ) % 256;
      float CproxSatura = ( Csatura+CincSatura ) % 256;
      float CproxBrillo = ( Cbrillo+CincBrillo ) % 256;

      for ( int i=0 ; i<cantidad ; i++ ) {
        imagen.pushMatrix();
        imagen.translate( ancho*x[i], alto*y[i] );
        imagen.rotate( ang[i] );
        imagen.rect( 0, 0, ancho*factor[i], alto*factor[i] );
        imagen.translate( ancho*factor[i]*-0.5, alto*factor[i]*-0.5 );

        pushStyle();
        ejecutar( nivel-1, ancho*factor[i], alto*factor[i], 
        proxTinte, proxSatura, proxBrillo, 
        CproxTinte, CproxSatura, CproxBrillo 
          );
        popStyle();

        imagen.popMatrix();
      }
    }
  }

  void dibujar( float x, float y ) {
    image( imagen, x, y );
  }

  void string() {
    println("cantidad="+cantidad);
    println( "-factor---------" );
    println( factor );
    println( "-x---------" );
    println( x );
    println( "-y---------" );
    println( y );
    println( "-ang---------" );
    println( ang );
    println(  "iniTinte="+iniTinte);
    println(  "iniSatura="+iniSatura);
    println(  "iniBrillo="+iniBrillo);
    println(  "incTinte="+incTinte);
    println(  "incSatura="+incSatura);
    println(  "incBrillo="+incBrillo);
    println(  "transparencia="+transparencia);     
    println(  "CiniTinte="+CiniTinte);
    println(  "CiniSatura="+CiniSatura);
    println(  "CiniBrillo="+CiniBrillo);
    println(  "CincTinte="+CincTinte);
    println(  "CincSatura="+CincSatura);
    println(  "CincBrillo="+CincBrillo);
    println(  "Ctransparencia="+Ctransparencia);
  }
}
