/**
 Fractal con segmentos por recursión - 
 Emiliano Causa 2011 -
 emiliano.causa@gmail.com
 **/
int profundidad = 1;
int cantidad = 3;
float x1[] = { 
  0.0, 0.3, 0.3
};
float y1[] = { 
  0.0, -0.1, -0.1
};
float x2[] = { 
  0.3, 0.5, 1.0
};
float y2[] = { 
  -0.1, 0.5, -0.3
};
//---------------------
void setup() {
  size( 500, 500 );
  frameRate(1);
  smooth();
}
//---------------------
void draw() {
  profundidad = (profundidad+1) % 12;
  background( 255 );
  fractal( profundidad, 50, 300, 370, 300 );
}
//---------------------
void fractal( int nivel, float xp1, float yp1, float xp2, float yp2 ) {

  if ( nivel>0 ) {

    float verde = map( nivel, 0, profundidad, 0, 255 );
    float azul = map( nivel, 0, profundidad, 255, 0 );
    float alfa = map( nivel, 0, profundidad, 20, 250 );
    stroke( verde, 0, azul, alfa );

    float distancia = dist( xp1, yp1, xp2, yp2 );
    float angulo = atan2( yp2-yp1, xp2-xp1 );

    if ( distancia>0 ) {
      pushMatrix();
      translate( xp1, yp1 );
      rotate( angulo );

      for ( int i=0 ; i<cantidad ; i++ ) { 

        float nx1 = x1[i] * distancia;
        float ny1 = y1[i] * distancia;
        float nx2 = x2[i] * distancia;
        float ny2 = y2[i] * distancia;

        line( nx1, ny1, nx2, ny2 );
        fractal( nivel-1, nx1, ny1, nx2, ny2 );
      }

      popMatrix();
    }
  }
}

