//------------------------------------------------------------------------------------------------------------
// Organismo - Organismo - Organismo - Organismo - Organismo - Organismo - Organismo - Organismo - Organismo - 
//------------------------------------------------------------------------------------------------------------
//
//  Emiliano Causa 2007
//  e_causa@yahoo.com.ar
//  www.emiliano-causa.com.ar
//  www.biopus.com.ar
//
class Organismo{

  float x, y; //posicion del organismo
  float direccion; //dirección en la que avanza
  float velocidad; //velocidad a la que avanza
  float dx,dy;  //desplazamiento en x e y deducido de la dirección y velocidad.
  float radio = 10; //tamaño del objeto
  boolean toroidal; //especifica el tipo de espacio

    int especie; //define la especie
  color borde,relleno;

  int conducta;
  Organismo elOtro;

  //define estas variables que serán usadas como constantes de especie
  int PLANTA = 0;
  int HERVIBORO = 1;
  int DEPREDADOR = 2;

  //define estas variables que seran usadas como constantes de conductas
  //también sirve para declarar las prioridades 
  int INDIFERENCIA = 0;
  int ALEJARSE = 1;
  int PERSEGUIR = 2;
  int ESQUIVAR = 3;
  int REPRODUCIR = 4;
  int HUIR = 5;
  int COMER = 6;

  //----------------------------  

  Organismo(  float x_ , float y_ ){ //inicializa el organismo
    iniciar( x_ , y_ ); 
  }
  //----------------------------  

  Organismo( ){ //inicializa el organismo
    iniciar( random(width) , random(height) ); //si no recibe parametros inicia con x e y al azar
    asignarEspecieAlAzar( 15 , 25 );  //le asigna una especie al azar
    defineCaracteristicas(); //define sus característica según la especia
  }
  //----------------------------  

  void iniciar( float x_ , float y_ ){  //inicialización del organismo
    x = x_;
    y = y_;
    direccion = random(TWO_PI); //inicia con una dirección al azar
    toroidal = true; //esta variable activa el espacio toroidal
    conducta = INDIFERENCIA; //al inicio el organismos se mueve libremente

  }
  //----------------------------  

  void mover(){  //actualiza la ubicación del organismo
    variarAngulo( 30 );  //caria la direccion en un rango de 30 grados para cada lado
    dx = velocidad * cos(direccion);  //deduce el desplazamiento en X
    dy = velocidad * sin(direccion);  //deduce el desplazamiento en Y
    x += dx; //aplica los desplazamiento
    y += dy; //aplica los desplazamiento

    if( toroidal ){ //si el espacio es toroidal entonces revisa si se pasó de límite
      x = ( x>width ? x-width : x );
      x = ( x<0 ? x+width : x );      
      y = ( y>height ? y-height : y );
      y = ( y<0 ? y+height : y );      
    }
  }
  //----------------------------  

  void dibujar(){  //dibuja el organismo
    stroke(borde);
    fill(relleno);

    if( especie == PLANTA ){ //si es una planta lo dibuja como a un círculo
      ellipse(x,y,radio,radio);
    }
    else if( especie == HERVIBORO ){ //si es herviboro lo dibuja como a un triangulo
      pushMatrix();
      translate(x,y);
      rotate(direccion+HALF_PI);
      triangle(0,-radio,radio,radio,-radio,radio);
      popMatrix();
    }
    else{ //si es depredador lo dibuja como a un rectángulo
      rectMode(CENTER);
      pushMatrix();
      translate(x,y);
      rotate(direccion);
      rect(0,0,radio*2,radio*2);
      popMatrix();
    }
  }
  //----------------------------  

  void variarAngulo( float amplitud ){  //varia la dirección con una amplitud determinada
    float radi = radians( amplitud ); //transforma los grados en radianes
    direccion += random( -radi , radi ); //aplica un valor al azar dentro del rango
  }
  //----------------------------  

  void asignarEspecieAlAzar( float probDepredador , float probHerviboro ){  //le asigna una especie al azar
    float valor = random(100);
    if( valor < probDepredador ){ //aplica la probabilidad para los depredadores
      especie = DEPREDADOR;
    }
    else if( valor < probDepredador+probHerviboro ){ //aplica la probabilidad para los herviboros
      especie = HERVIBORO;
    }
    else{ // el resto son plantas
      especie = PLANTA;
    }
    defineCaracteristicas();
  }

  //----------------------------  

  void defineCaracteristicas(){  //define la velocidad de movimiento en función de la especie
    float tinta;
    if( especie == DEPREDADOR ){
      velocidad = 8;
      tinta = random( 0,30 );
    }
    else if( especie == HERVIBORO ){
      velocidad = 4;
      tinta = random( 150,250 );
    }
    else{
      velocidad = 0;
      tinta = random( 80,150 );
    }
    borde = color(tinta,150,150,200);
    relleno = color(tinta,300,300,100);

  }
  //----------------------------  

  void resolverEncuentro( Organismo otro ){

    float distancia = dist( x , y , otro.x , otro.y );
    int actitudConEste;

    if( distancia < radio*2 ){ //si lo está tocando
      actitudConEste = ESQUIVAR;
    }
    else if( distancia < radio*6 ){ //si está a un cuerpo de distancia
      actitudConEste = ESQUIVAR;
    }
    else{
      actitudConEste = INDIFERENCIA;
    }

    if( actitudConEste > conducta ){
      conducta = actitudConEste;
      elOtro = otro;
    }

  }
  //----------------------------  

  void accionar(){
    if( conducta == INDIFERENCIA ){
      mover();
    }
    else if( conducta == ESQUIVAR ){
      huirDelOtro( elOtro );
    }
    conducta = INDIFERENCIA;
  }  

  //----------------------------  

  void huirDelOtro( Organismo otro ){
    direccion = atan2( y-otro.y , x-otro.x );    
    mover();
  }
  //----------------------------  

}

