class Ecosistema{

  Organismo[] animales;  //Un arreglo de animales
  int cantOrganismos;  //Define la cantidad de organismos
  Territorio miTerritorio;  //define una variable para administra el territorio
  int celdas;  //define la matriz del territorio, en este caso es de 4x4 celdas
  float probabilidadDepredadores = 5;
  float probabilidadHerviboros = 35;

    //---------------------------- 
  Ecosistema( int cantOrganismos_ , int celdas_ ){
    cantOrganismos = cantOrganismos_;
    celdas = celdas_;
    iniciar_Organismos();
  }
  //---------------------------- 

  void iniciar_Organismos(){

    animales = new Organismo[cantOrganismos];  //Se inicia el arreglo
    for(int i=0;i<cantOrganismos;i++){   //se recorre cada animal
      animales[i] = new Organismo();  // se inicia cada animal
      animales[i].asignarEspecieAlAzar( probabilidadDepredadores , probabilidadHerviboros );
    }
  }
  //---------------------------- 

  void revisar_Territorio(){
    miTerritorio = new Territorio( width , height , celdas , celdas );
    for(int i=0;i<cantOrganismos;i++){  //se recorre cada animal y :
      if( animales[i].vive() ){ //solo si esta vivo
        miTerritorio.ubicar( animales[i].x , animales[i].y , i );
      }
    }
  }
  //---------------------------- 
  void resolver_Encuentros_Organismos(){

    int limiteEncuentros = 20;

    for( int i=0 ; i<miTerritorio.col ; i++ ){     //recorre una por una las
      for( int j=0 ; j<miTerritorio.filas ; j++ ){ //celdas del territorio

        T_Lugar esteLugar = miTerritorio.lugar( i , j ); //toma cada lugar del territorio
        for( int k=0 ; k < esteLugar.cantidad-1 && k<limiteEncuentros ; k++ ){
          // toma uno por uno los objetos de este lugar
          int id1 = esteLugar.id[k]; // recupera el id

          for( int l=k+1 ; l < esteLugar.cantidad && l<limiteEncuentros ; l++ ){
            // toma otro objeto del lugar
            int id2 = esteLugar.id[l]; // recupera el id

            animales[id1].resolverEncuentro( animales[id2] ); // enfrenta al organismo 1 con el 2
            animales[id2].resolverEncuentro( animales[id1] ); // enfrenta al organismo 2 con el 1
          }
        }
      }
    }
  }
  //---------------------------- 
  void accionar_Organismos(){
    for(int i=0;i<cantOrganismos;i++){  //se recorre cada animal y :
      if( animales[i].vive() ){ //solo si esta vivo
        animales[i].accionar();  //cada uno amina hacia la comida y actualiza su energia
      }
    }
  }
  //---------------------------- 
  void dibujar_Organismos(){
    for(int i=0;i<cantOrganismos;i++){  //se recorre cada animal y :
      if( animales[i].vive() ){ //solo si esta vivo
        animales[i].dibujar();  //dibuja cada animal
      }
    }
  }
  //---------------------------- 
}

