//------------------------------------------------------------------------------------------------------------
// Organismo - Organismo - Organismo - Organismo - Organismo - Organismo - Organismo - Organismo - Organismo - 
//------------------------------------------------------------------------------------------------------------
//
//  Emiliano Causa 2007
//  e_causa@yahoo.com.ar
//  www.emiliano-causa.com.ar
//  www.biopus.com.ar
//
class Organismo{

  float x, y; //posicion del organismo
  float direccion; //dirección en la que avanza
  float velocidad; //velocidad a la que avanza
  float dx,dy;  //desplazamiento en x e y deducido de la dirección y velocidad.
  float radio = 10; //tamaño del objeto
  boolean toroidal; //especifica el tipo de espacio

  boolean estaVivo; //indica si está vivo o no

    int especie; //define la especie
  color borde,relleno;

  int conducta; //registra la conducta a llevar a cabo 
  Organismo elOtro; //registra el organismo objeto de la conducta

  //define estas variables que serán usadas como constantes de especie
  int PLANTA = 0;
  int HERVIBORO = 1;
  int DEPREDADOR = 2;

  //define estas variables que seran usadas como constantes de conductas
  //también sirve para declarar las prioridades 
  int INDIFERENCIA = 0;
  int ALEJARSE = 1;
  int PERSEGUIR = 2;
  int ESQUIVAR = 3;
  int REPRODUCIR = 4;
  int HUIR = 5;
  int COMER = 6;

  //estas son las matrices de conductas  
  int conductaColision[][];
  int conductaCerca[][];
  int conductaLejos[][];
  //----------------------------  

  Organismo(  float x_ , float y_ ){ //inicializa el organismo
    iniciar( x_ , y_ ); 
  }
  //----------------------------  

  Organismo( ){ //inicializa el organismo
    iniciar( random(width) , random(height) ); //si no recibe parametros inicia con x e y al azar
    asignarEspecieAlAzar( 15 , 25 );  //le asigna una especie al azar
    defineCaracteristicas(); //define sus característica según la especia
  }
  //----------------------------  

  void iniciar( float x_ , float y_ ){  //inicialización del organismo
    x = x_;
    y = y_;
    direccion = random(TWO_PI); //inicia con una dirección al azar
    toroidal = true; //esta variable activa el espacio toroidal
    estaVivo = true; //inicia al objeto como vivo
    conducta = INDIFERENCIA; //al inicio el organismos se mueve libremente
    iniciarMatricesDeConducta();

  }
  //----------------------------  
  void iniciarMatricesDeConducta(){

    conductaColision = new int[3][3];
    conductaCerca = new int[3][3];
    conductaLejos = new int[3][3];

    // conducta para cuando dos organismos COLISIONAN
    conductaColision[ PLANTA ][ PLANTA ] = INDIFERENCIA;
    conductaColision[ PLANTA ][ HERVIBORO ] = INDIFERENCIA;
    conductaColision[ PLANTA ][ DEPREDADOR ] = INDIFERENCIA;

    conductaColision[ HERVIBORO ][ PLANTA ] = COMER;
    conductaColision[ HERVIBORO ][ HERVIBORO ] = ESQUIVAR;
    conductaColision[ HERVIBORO ][ DEPREDADOR ] = HUIR;

    conductaColision[ DEPREDADOR ][ PLANTA ] = ESQUIVAR;
    conductaColision[ DEPREDADOR ][ HERVIBORO ] = COMER;
    conductaColision[ DEPREDADOR ][ DEPREDADOR ] = ESQUIVAR;

    // conducta para cuando dos organismos ESTAN CERCA
    conductaCerca[ PLANTA ][ PLANTA ] = INDIFERENCIA;
    conductaCerca[ PLANTA ][ HERVIBORO ] = INDIFERENCIA;
    conductaCerca[ PLANTA ][ DEPREDADOR ] = INDIFERENCIA;

    conductaCerca[ HERVIBORO ][ PLANTA ] = PERSEGUIR;
    conductaCerca[ HERVIBORO ][ HERVIBORO ] = INDIFERENCIA;
    conductaCerca[ HERVIBORO ][ DEPREDADOR ] = ALEJARSE;

    conductaCerca[ DEPREDADOR ][ PLANTA ] = INDIFERENCIA;
    conductaCerca[ DEPREDADOR ][ HERVIBORO ] = PERSEGUIR;
    conductaCerca[ DEPREDADOR ][ DEPREDADOR ] = INDIFERENCIA;

    // conducta para cuando dos organismos ESTAN LEJOS
    conductaLejos[ PLANTA ][ PLANTA ] = INDIFERENCIA;
    conductaLejos[ PLANTA ][ HERVIBORO ] = INDIFERENCIA;
    conductaLejos[ PLANTA ][ DEPREDADOR ] = INDIFERENCIA;

    conductaLejos[ HERVIBORO ][ PLANTA ] = INDIFERENCIA;
    conductaLejos[ HERVIBORO ][ HERVIBORO ] = INDIFERENCIA;
    conductaLejos[ HERVIBORO ][ DEPREDADOR ] = ALEJARSE;

    conductaLejos[ DEPREDADOR ][ PLANTA ] = INDIFERENCIA;
    conductaLejos[ DEPREDADOR ][ HERVIBORO ] = PERSEGUIR;
    conductaLejos[ DEPREDADOR ][ DEPREDADOR ] = INDIFERENCIA;

  }  
  //----------------------------  

  void mover(){  //actualiza la ubicación del organismo
    variarAngulo( 30 );  //caria la direccion en un rango de 30 grados para cada lado
    dx = velocidad * cos(direccion);  //deduce el desplazamiento en X
    dy = velocidad * sin(direccion);  //deduce el desplazamiento en Y
    x += dx; //aplica los desplazamiento
    y += dy; //aplica los desplazamiento

    if( toroidal ){ //si el espacio es toroidal entonces revisa si se pasó de límite
      x = ( x>width ? x-width : x );
      x = ( x<0 ? x+width : x );      
      y = ( y>height ? y-height : y );
      y = ( y<0 ? y+height : y );      
    }
  }
  //----------------------------  

  void dibujar(){  //dibuja el organismo
    stroke(borde);
    fill(relleno);

    if( especie == PLANTA ){ //si es una planta lo dibuja como a un círculo
      ellipse(x,y,radio,radio);
    }
    else if( especie == HERVIBORO ){ //si es herviboro lo dibuja como a un triangulo
      pushMatrix();
      translate(x,y);
      rotate(direccion+HALF_PI);
      triangle(0,-radio,radio,radio,-radio,radio);
      popMatrix();
    }
    else{ //si es depredador lo dibuja como a un rectángulo
      rectMode(CENTER);
      pushMatrix();
      translate(x,y);
      rotate(direccion);
      rect(0,0,radio*2,radio*2);
      popMatrix();
    }
  }
  //----------------------------  

  void variarAngulo( float amplitud ){  //varia la dirección con una amplitud determinada
    float radi = radians( amplitud ); //transforma los grados en radianes
    direccion += random( -radi , radi ); //aplica un valor al azar dentro del rango
  }
  //----------------------------  

  void asignarEspecieAlAzar( float probDepredador , float probHerviboro ){  //le asigna una especie al azar
    float valor = random(100);
    if( valor < probDepredador ){ //aplica la probabilidad para los depredadores
      especie = DEPREDADOR;
    }
    else if( valor < probDepredador+probHerviboro ){ //aplica la probabilidad para los herviboros
      especie = HERVIBORO;
    }
    else{ // el resto son plantas
      especie = PLANTA;
    }
    defineCaracteristicas();
  }

  //----------------------------  

  void defineCaracteristicas(){  //define la velocidad de movimiento en función de la especie
    float tinta;
    if( especie == DEPREDADOR ){
      velocidad = 8;
      tinta = random( 0,30 );
    }
    else if( especie == HERVIBORO ){
      velocidad = 4;
      tinta = random( 150,250 );
    }
    else{
      velocidad = 0;
      tinta = random( 80,150 );
    }
    borde = color(tinta,150,150,200);
    relleno = color(tinta,300,300,100);

  }
  //----------------------------  

  void morir(){
    estaVivo = false;
  }
  //----------------------------  

  boolean vive(){
    return estaVivo;
  }
  //----------------------------  

  void resolverEncuentro( Organismo otro ){

    float distancia = dist( x , y , otro.x , otro.y );
    int actitudConEste;

    if( distancia < radio*2 ){ //si lo está tocando
      actitudConEste = conductaColision[ especie ][ otro.especie ];
    }
    else if( distancia < radio*6 ){ //si está a un cuerpo de distancia
      actitudConEste = conductaCerca[ especie ][ otro.especie ];
    }
    else{
      actitudConEste = conductaLejos[ especie ][ otro.especie ];
    }

    if( actitudConEste > conducta ){
      conducta = actitudConEste;
      elOtro = otro;
    }

  }
  //----------------------------  

  void accionar(){
    if( conducta == INDIFERENCIA ){
      mover();
    }
    else if( conducta == HUIR ){
      huirDelOtro( elOtro );
    }
    else if( conducta == ESQUIVAR ){
      huirDelOtro( elOtro );
    }
    else if( conducta == COMER ){
      comerAlOtro( elOtro );
    }
    else if( conducta == REPRODUCIR ){
      //SIN IMPLEMENTAR
      mover();
    }
    else if( conducta == ALEJARSE ){
      huirDelOtro( elOtro );
    }
    else if( conducta ==  PERSEGUIR ){
      perseguirAlOtro( elOtro );
    }
    conducta = INDIFERENCIA;
  }  

  //----------------------------  

  void huirDelOtro( Organismo otro ){
    direccion = atan2( y-otro.y , x-otro.x );    
    mover();
  }
  //----------------------------  

  void perseguirAlOtro( Organismo otro ){
    direccion = atan2( otro.y-y , otro.x-x );    
    mover();
  }
  //----------------------------  

  void comerAlOtro( Organismo otro ){
    otro.morir();
  }
  //----------------------------  

}

