// Actualizada al 5/Ago/2007 v1.1 
//---------------------------------------------------------------------------------------------------------------
// MARCA: Territorio - Territorio - Territorio - Territorio - Territorio - Territorio - Territorio - Territorio -
//---------------------------------------------------------------------------------------------------------------
//
//  Emiliano Causa 2007
//  e_causa@yahoo.com.ar
//  www.emiliano-causa.com.ar
//  www.biopus.com.ar
//
//  Territorio( float anchoPantalla , float altoPantalla , int filas_ , int col_ )
//
//  void ubicar( float x , float y , int id )
//
//  T_Lugar lugar( int col , int fila )
//
class Territorio{
  float ancho;
  float alto;
  int filas;
  int col;
  int modH,modV;

  T_Lugar lugares[][];
  //--------------------------

  Territorio( float anchoPantalla , float altoPantalla , int filas_ , int col_ ){
    //inicializa el objeto definiendo la matriz de celdas
    ancho = anchoPantalla;
    alto = altoPantalla;
    filas = filas_;
    col = col_;
    modH = int(ancho/col);
    modV = int(alto/filas);

    lugares = new T_Lugar[ col ][ filas ];
    for(int i=0;i<col;i++){
      for(int j=0;j<filas;j++){
        lugares[i][j] = new T_Lugar(i,j);
      }
    }
  }
  //--------------------------

  void ubicar( float x , float y , int id ){ //este comportamiento ubica a cada objeto en su celda
    if( x>0 && x<ancho && y>0 && y<alto){
      int cualX = int(x/modH);  //define el lugar horizontal en el que cae el objeto
      int cualY = int(y/modV);  //define el lugar vertical en el que cae el objeto
      cualX = (cualX >= col ? col-1 : cualX);
      cualY = (cualY >= filas ? filas-1 : cualY);
      
      lugares[ cualX ][ cualY ].agregar( x , y , id ); //agrega el objeto en la celda elegida
    }
  }
  //--------------------------

  T_Lugar lugar( int col , int fila ){ //retorna un seleccionado por fila y columna
    return lugares[ col ][ fila ];
  }
  //--------------------------

  void imprimirGrilla(){
    for( int i=0 ; i<col ; i++ ){
      line( i*modH , 0 , i*modH , alto );
    }
    for( int j=0 ; j<filas ; j++ ){
      line( 0 , j*modV , ancho , j*modV );
    }
  }

}
//---------------------------------------------------------------------------------------------------------------
// MARCA: T_Lugar - T_Lugar - T_Lugar - T_Lugar - T_Lugar - T_Lugar - T_Lugar - T_Lugar - T_Lugar - T_Lugar -
//---------------------------------------------------------------------------------------------------------------
class T_Lugar{
  int cantidad;
  int limite;
  int fila,col;
  float x[], y[];
  int id[];
  //--------------------------

  T_Lugar( int col_ , int fila_ ){
    fila = fila_;
    col = col_;
    cantidad = 0;
    limite = 100;
    x = new float[limite];
    y = new float[limite];    
    id = new int[limite];
  }
  //--------------------------

  void agregar( float x_ , float y_ , int id_ ){
    if( cantidad < limite-1 ){
      x[ cantidad ] = x_;
      y[ cantidad ] = y_;  
      id[ cantidad ] = id_;  
      cantidad ++;
    }
  }
  //--------------------------

  void string(){
    println(" Lugar[ "+col+" ][ "+fila+" ]");
    println("   Cantidad=" + cantidad );  
    for(int i=0;i<cantidad;i++){
      println("      id( "+id[i]+" )-->( "+nfc(x[i],2)+" | "+nfc(y[i],2)+" )");
    }
  }
  //--------------------------

  void imprimir(){
    for(int i=0;i<cantidad;i++){
      ellipse(x[i],y[i],50,50);
    }
  }
}

